_DATA		SEGMENT
;CD Drive Status
PlayStrtAdrs	dd	0000h
PlayEndAdrs	dd	0000h
CurrentAdrs	dd	0000h
PauseStatus	db	0

DriveStat	dw	0
PlayOffset	dw	150
_DATA		ENDS


_MAIN		SEGMENT
		AssumeES
		assume	ds:NOTHING

; Check Device Status
; INPUT
;	es:bx	DOSReqWork
;	es:si	IOCTLWork
;
; RETURN VALUE
;  ah =	00h : No Error
;	10h : Playing
;	80h : Hard Error
;  cx =	Error Info
;
ChkDevStat	proc	near
		call	DosChkMedChg
		cmp	es:[si.I_MedChgStat], 0ffh	; 01h = Not Changed
							; ffh = Disk Changed
		jne	ChkPlayStat
		mov	cx, 0080h	; media changed
		jmp	short ChkDevStatErr
ChkPlayStat:
		mov	ah, byte ptr es:[bx.D_Stat+1]
		test	ah, 02h			; playing ?
		jz	@f
		mov	ah, 10h			; set playing bit
		jmp	short ChkDevStatExit
@@:
		mov	ah, byte ptr es:[bx.D_Stat+1]
		test	ah, 80h			; error ?
		jnz	ChkErrStat

		cmp	cs:[DriveStat], 8001h
		jne	@f
		mov	cx, 0080h	; media changed
		jmp	short ChkDevStatErr
@@:
		xor	ah, ah
		jmp	short ChkDevStatExit
ChkErrStat:
		mov	ah, byte ptr es:[bx.D_Stat]
		cmp	ah, 02h
		jne	@f
		mov	cx, 0001h	; not ready
		jmp	short ChkDevStatErr
@@:
		cmp	ah, 03h
		jne	@f
		mov	cx, 0002h	; parameter error
		jmp	short ChkDevStatErr
@@:
		cmp	ah, 07h
		jne	@f
		mov	cx, 0010h	; media error
		jmp	short ChkDevStatErr
@@:
;		mov	cx, 0004h	; not connect
		mov	cx, 0008h	; command abort
;		mov	cx, 0020h	; hard error
ChkDevStatErr:
		mov	ah, 80h
ChkDevStatExit:
		mov	byte ptr cs:[DriveStat], cl
		mov	byte ptr cs:[DriveStat+1], ah
		ret
ChkDevStat	endp



CDBIOSDone	proc	near
		xor	ah, ah
		ret
CDBIOSDone	endp


CDSetDrvMode	proc	near
		cmp	ch, 00h
		jne	CDSetDrvModeErr
		cmp	dl, 04h
		jne	CDSetDrvModeErr
		mov	ah, 00h
		ret
CDSetDrvModeErr:
		mov	ah, 80h
		mov	cx, 0002h
		ret
CDSetDrvMode	endp


CDGetDrvMode	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		xor	ah, ah
		mov	dl, 04h
		ret
CDGetDrvMode	endp


CDGetDrvStat	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 00h
		je	@f
		pop	bx
		pop	si
		pop	es
		ret
@@:
		call	DosGetVolSize
		pop	bx
		mov	ax, 0004h
		mov	dx, word ptr es:[si.I_VolSize]
		mov	bx, word ptr es:[si.I_VolSize+2]
		pop	si
		pop	es
		ret
CDGetDrvStat	endp




CDPlay	proc	near
;		cmp	cx, 0001h
		cmp	cl, 01h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI		

		call	ChkDevStat
		cmp	ah, 00h
		jne	CDPlayExit

		call	DosGetAudChnl
		call	DosSetAudChnl

		push	ax
		push	dx

		mov	al, byte ptr ds:[di.B_EndAdrs]	;|Save End Address
		mov	byte ptr es:[PlayEndAdrs], al	;|
		mov	dx, word ptr ds:[di.B_EndAdrs+1];|
		mov	word ptr es:[PlayEndAdrs+1], dx	;|

		xchg	dh, dl
		call	MSF2HSG	
		mov	word ptr es:[bx.D_PlayCnt], dx
		mov	word ptr es:[bx.D_PlayCnt+2], ax

		mov	al, byte ptr ds:[di.B_StrtAdrs]	 ;|Save Start Address
		mov	byte ptr es:[PlayStrtAdrs], al	 ;|
		mov	dx, word ptr ds:[di.B_StrtAdrs+1];|
		mov	word ptr es:[PlayStrtAdrs+1], dx ;|
		xchg	dh, dl
		call	MSF2HSG
		sub	word ptr es:[bx.D_PlayCnt], dx	;|Set play count
		sbb	word ptr es:[bx.D_PlayCnt+2], ax;|

		sub	dx, word ptr es:[PlayOffset]	;| offset start positon
		sbb	ax, 0				;|
		mov	es:[bx.D_AdrsMode], 0		; Set HSG Address Mode
		mov	word ptr es:[bx.D_StrtAdrs], dx
		mov	word ptr es:[bx.D_StrtAdrs+2], ax

		call	DosCDStop
		call	DosCDPlay

		pop	dx
		pop	ax

		mov	es:[PauseStatus], 0
		xor	ah, ah

CDPlayExit:
		pop	bx
		pop	si
		pop	es
		ret
CDPlay		endp



CDResume	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 80h
		je	CDResumeExit

		test	es:[PauseStatus], 1
		jnz	@f
		mov	ah, 23h
		jmp	CDResumeExit
@@:
		push	ax
		push	dx

		mov	al, byte ptr es:[PlayEndAdrs]
		mov	dx, word ptr es:[PlayEndAdrs+1]
		xchg	dh, dl
		call	MSF2HSG
		mov	word ptr es:[bx.D_PlayCnt], dx
		mov	word ptr es:[bx.D_PlayCnt+2], ax

		mov	al, byte ptr es:[CurrentAdrs]
		mov	dx, word ptr es:[CurrentAdrs+1]
		xchg	dh, dl
		call	MSF2HSG
		sub	word ptr es:[bx.D_PlayCnt], dx
		sbb	word ptr es:[bx.D_PlayCnt+2], ax

		sub	dx, 150
		sbb	ax, 0
		mov	es:[bx.D_AdrsMode], 0	; set HSG Address Mode
		mov	word ptr es:[bx.D_StrtAdrs], dx
		mov	word ptr es:[bx.D_StrtAdrs+2], ax


		call	DosCDPlay

		pop	dx
		pop	ax

		mov	es:[PauseStatus], 0
		xor	ah, ah

CDResumeExit:
		pop	bx
		pop	si
		pop	es
		ret
CDResume	endp



CDStop		proc	near
; YS  This function (CH==0FFH) does not exist in SCSI-2 command
; YS  But, at least it shouldn't return an error.
; AH=52H, CH=0FFH means set sleep timer.
		cmp		ch,0ffh
		jne		@f
		mov		ah,	0
		ret

@@:
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret

@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI		

		call	ChkDevStat
		cmp	ah, 80h
		je	CDStopExit

		call	DosCDStop
;		call	DosCDStop

		mov	es:[PauseStatus], 0
		xor	ah, ah
CDStopExit:
		pop	bx
		pop	si
		pop	es
		ret
CDStop		endp


CDPause		proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 80h
		je	CDPauseExit

		test	es:[PauseStatus], 1
		jz	@f
		mov	ah, 22h
		jmp	CDPauseExit
@@:

		call	DosGetQInfo
		push	ax
		mov	al, byte ptr es:[si.I_TimeInDsk]
		mov	byte ptr es:[CurrentAdrs], al
		mov	ax, word ptr es:[si.I_TimeInDsk+1]
		mov	word ptr es:[CurrentAdrs+1], ax
		pop	ax

		call	DosCDStop

		mov	es:[PauseStatus], 1
		xor	ah, ah
CDPauseExit:
		pop	bx
		pop	si
		pop	es
		ret
CDPause		endp


GetPlayInfo	proc	near
		cmp	cx, 0001h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 80h
		je	GetPlayInfoExit

		push	ax

		mov	al, byte ptr es:[PlayStrtAdrs]
		mov	byte ptr ds:[di.B_StrtAdrs], al
		mov	ax, word ptr es:[PlayStrtAdrs+1]
		mov	word ptr ds:[di.B_StrtAdrs+1], ax

		mov	al, byte ptr es:[PlayEndAdrs]
		mov	byte ptr ds:[di.B_EndAdrs], al
		mov	ax, word ptr es:[PlayEndAdrs+1]
		mov	word ptr ds:[di.B_EndAdrs+1], ax

		pop	ax

		xor	ah, ah
GetPlayInfoExit:
		pop	bx
		pop	si
		pop	es
		ret
GetPlayInfo	endp


GetQinfo	proc	near
		cmp	cx, 0000h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 80h
		je	GetQInfoExit

		call	DosGetQInfo

		mov	ax, es:[si.I_TNOandIndex]	;| Convert Track No
		call	BCD2BIN				;|and Index
		xchg	ah, al				;|from BCD to HEX
		call	BCD2BIN				;|
		xchg	ah, al				;|
		mov	ds:[di.B_TNOandIndex], ax	;|

		push	dx

		mov	al, byte ptr es:[si.I_TimeInTrk]
		mov	dx, word ptr es:[si.I_TimeInTrk+1]
		mov	byte ptr ds:[di.B_TimeInTrk], al
		mov	word ptr ds:[di.B_TimeInTrk+1], dx

		mov	al, byte ptr es:[si.I_TimeInDsk]
		mov	dx, word ptr es:[si.I_TimeInDsk+1]
		mov	byte ptr ds:[di.B_TimeInDsk], al
		mov	word ptr ds:[di.B_TimeInDsk+1], dx

		pop	dx
		
		xor	ax, ax
		test	es:[bx.D_Stat], 0200h	; test playing bit
		jz	@f
		or	al, 01h
@@:
GetQInfoExit:
		pop	bx
		pop	si
		pop	es
		ret
GetQinfo	endp



GetCDInfo	proc	near
		cmp	cx, 0000h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		push	ax
		push	dx

		call	DosResetDrv
		call	DosGetAudChnl
		call	DosSetAudChnl

		call	ChkDevStat
		cmp	ah, 80h
		je	GetCDInfoExit

		call	DosGetAudDsk
		mov	ax, es:[si.I_MinMaxTrkNo]	 ;|Store Start Track No
		mov	word ptr ds:[di.B_StrtTrkNo], ax ;|and End Track No.
		
		call	DosGetVolSize
		mov	dx, word ptr es:[si.I_VolSize]
		mov	ax, word ptr es:[si.I_VolSize+2]
		add	dx, 150
		adc	ax, 0
		call	HSG2MSF
		mov	byte ptr ds:[di.B_TotalTime], al
		xchg	dh, dl
		mov	word ptr ds:[di.B_TotalTime+1], dx


		push	di
		push	cx
		mov	cx, word ptr ds:[di.B_StrtTrkNo]
		xor	dx, dx
		add	di, BIOS_DskInfo.B_TrackInfo
GetCDInfoLoop:
		mov	es:[si.I_TrkNo], cl
		call	DosGetAudTrk

		mov	dh, 01h
		mov	ax, word ptr es:[si.I_CtrlInfo]

		mov	al, byte ptr es:[si.I_TrkSize+2];|<- Min.
		cmp	ah, 41h				;||<- Data Track ?
		jne	@f				;||
		or	al, 80h				;||
		shl	dh, 1				;||
@@:		or	dl, dh				;||
		mov	byte ptr ds:[di], al		;|

		mov	ax, word ptr es:[si.I_TrkSize]	;|<- Sec., Frame
		xchg	ah, al				;|
		mov	word ptr ds:[di+1], ax

		add	di, 3
		inc	cl
		cmp	cl, ch
		jle	GetCDInfoLoop

		pop	cx
		pop	di

		mov	ds:[di.B_DiskType], dl

		pop	dx
		pop	ax

		call	ChkDevStat
GetCDInfoExit:
		pop	bx
		pop	si
		pop	es
		ret
GetCDInfo	endp



CDSeekCyl0	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	dx
		push	cx

		xor	cx, cx
		mov	dx, cx
		call	CDSeekMSF

		cmp	ah, 80h
		jne	@f
		pop	dx
		pop	dx
		ret
@@:
		pop	cx
		pop	dx
		ret
CDSeekCyl0	endp



CDSeekHSG	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 00h
		jne	CDSeekHSGExit

		mov	word ptr es:[bx.D_BlkAdrs], dx
		mov	word ptr es:[bx.D_BlkAdrs+2], cx
		mov	es:[bx.D_AdrsMode], 0	; set HSG Address Mode

		call	DosCDSeek

		mov	es:[PauseStatus], 0
		xor	ah, ah
CDSeekHSGExit:
		pop	bx
		pop	si
		pop	es
		ret
CDSeekHSG	endp



CDReadHSG	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si

		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 00h
		pop	si			; si <- bx
		jne	CDReadHSGExit

		mov	es:[bx.D_AdrsMode], 0	; set HSG Address Mode
		mov	word ptr es:[bx.D_BlkAdrs], dx
		mov	word ptr es:[bx.D_BlkAdrs+2], cx

		mov	es:[bx.D_TfrCnt], si

		mov	word ptr es:[bx.D_BufAdrs], di
		mov	word ptr es:[bx.D_BufAdrs+2], ds
		mov	es:[bx.D_RedMode], 0

		call	DosCDRead

		sub	si, es:[bx.D_TfrCnt]
		mov	bx, si

		mov	es:[PauseStatus], 0
		xor	ah, ah
CDReadHSGExit:
		pop	si
		pop	es
		ret
CDReadHSG	endp




CDSeekMSF	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si
		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 00h
		jne	CDSeekMSFExit

		mov	es:[bx.D_AdrsMode], 1	; set MSF Address Mode
		mov	word ptr es:[bx.D_BlkAdrs], dx
		mov	word ptr es:[bx.D_BlkAdrs+2], cx

		call	DosCDSeek

		mov	es:[PauseStatus], 0
		xor	ah, ah
CDSeekMSFExit:
		pop	bx
		pop	si
		pop	es
		ret
CDSeekMSF	endp


CDReadMSF	proc	near
		cmp	ch, 00h
		je	@f
		mov	ah, 80h
		mov	cx, 0002h
		ret
@@:
		push	es
		push	si

		push	bx
		SetES_BX_SI

		call	ChkDevStat
		cmp	ah, 00h
		pop	si			; si <- bx
		jne	CDReadMSFExit

		mov	es:[bx.D_AdrsMode], 1	; set MSF Address Mode
		mov	word ptr es:[bx.D_BlkAdrs], dx
		mov	word ptr es:[bx.D_BlkAdrs+2], cx

		mov	es:[bx.D_TfrCnt], si

		mov	word ptr es:[bx.D_BufAdrs], di
		mov	word ptr es:[bx.D_BufAdrs+2], ds
		mov	es:[bx.D_RedMode], 0

		call	DosCDRead

		sub	si, es:[bx.D_TfrCnt]
		mov	bx, si

		mov	es:[PauseStatus], 0
		xor	ah, ah
CDReadMSFExit:
		pop	si
		pop	es
		ret
CDReadMSF	endp


_MAIN		ENDS

